/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CTRLNUMENF                                               */
/* Tabela : CTRLNUMENF                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 26/02/2003 - Roberto Lopes Martins                                         */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CTRLNUMENF
BEFORE INSERT OR UPDATE OR DELETE
ON CTRLNUMENF FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCNNF := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDCTRLNUMENF,0) <> NVL(:NEW.CDCTRLNUMENF,0)) OR
         (NVL(:OLD.DSCTRLNUMENF,0) <> NVL(:NEW.DSCTRLNUMENF,0)) OR
         (NVL(:OLD.VRPEMINFRMNF,0) <> NVL(:NEW.VRPEMINFRMNF,0)) OR
         (NVL(:OLD.IDCONSDTEMIS,0) <> NVL(:NEW.IDCONSDTEMIS,0)) OR
         (NVL(:OLD.IDUTLOCAEMIS,0) <> NVL(:NEW.IDUTLOCAEMIS,0)) OR
         (NVL(:OLD.IDUTCTRLFORM,0) <> NVL(:NEW.IDUTCTRLFORM,0)) OR
         (NVL(:OLD.IDUTFILILCEM,0) <> NVL(:NEW.IDUTFILILCEM,0)) OR
         (NVL(:OLD.DTEMISCTNUNF,TO_DATE('31/12/1899','DD/MM/YYYY')) <>  NVL(:NEW.DTEMISCTNUNF,TO_DATE('31/12/1899','DD/MM/YYYY'))) THEN
         :NEW.DTULTATUCNNF := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CTRLNUMENF', '', 'CDCTRLNUMENF='||:OLD.CDCTRLNUMENF||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CTRLNUMENF MODIFY DTULTATUCNNF DEFAULT SYSDATE
/
