CREATE TABLE VND_DEPARTAMENTO (
   NRDEPARTAMENTO 		NUMBER 			NOT NULL , 
   NOME 				VARCHAR2(50), 
   NRORG                NUMBER 			DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
   IDATIVO              VARCHAR2(1)     DEFAULT 'S' NOT NULL
      CONSTRAINT CKC_IDATIVO_VND_DPTO CHECK (IDATIVO IN ('S','N')),
   DTINCLUSAO           DATE            NULL,
   DTULTATU             DATE            NULL,
   NRORGINCLUSAO      	NUMBER 			DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')  NULL, 
   CDOPERINCLUSAO    	VARCHAR2(12)  	DEFAULT '1' NULL,
   NRORGULTATU          NUMBER 			DEFAULT  SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
   CDOPERULTATU        	VARCHAR2(12)  	DEFAULT '1' )
/

ALTER TABLE VND_DEPARTAMENTO ADD CONSTRAINT PK_VND_DEPARTAMENTO PRIMARY KEY (NRDEPARTAMENTO)
/

ALTER TABLE VND_EQUIPAMENTO	ADD NR_PARAMETRO NUMBER(4) 
/

ALTER TABLE VND_EQUIPAMENTO	ADD 
	CONSTRAINT NRPARAM_EQUIP_FK FOREIGN KEY (NR_PARAMETRO)
		REFERENCES VND_DEPARTAMENTO(NRDEPARTAMENTO)
/

   CREATE TABLE GER_GRUPOPARCEIRO (
   NRGRUPOPARCEIRO 		NUMBER			NOT NULL, 
   NMGRUPOPARCEIRO 		VARCHAR2(250), 
   NRORG                NUMBER 			DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
   IDATIVO              VARCHAR2(1)     DEFAULT 'S' NOT NULL
      CONSTRAINT CKC_IDATIVO_GER_GRPPARC CHECK (IDATIVO IN ('S','N')),
   DTINCLUSAO           DATE            NULL,
   DTULTATU             DATE            NULL,
   NRORGINCLUSAO      	NUMBER 			DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')  NULL,
   CDOPERINCLUSAO    	VARCHAR2(12)  	DEFAULT '1' NULL,
   NRORGULTATU          NUMBER 			DEFAULT  SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
   CDOPERULTATU        	VARCHAR2(12)  	DEFAULT '1' )
/

CREATE UNIQUE INDEX VND_GRUPOPARCEIRO_PK ON GER_GRUPOPARCEIRO (NRGRUPOPARCEIRO)
/

ALTER TABLE GER_GRUPOPARCEIRO ADD CONSTRAINT VND_GRUPOPARCEIRO_PK PRIMARY KEY (NRGRUPOPARCEIRO)
/

ALTER TABLE VND_VENDEDOR ADD CDVENDVENDEDOR VARCHAR2(4)
/

ALTER TABLE VND_VENDEDOR ADD 
	CONSTRAINT CDVEND_VEND_FK FOREIGN KEY (CDVENDVENDEDOR)
		REFERENCES VENDEDOR(CDVENDEDOR)
/

ALTER TABLE VND_VENDEDOR ADD DTINICIOPERIOINATIVO VARCHAR(15)
/

ALTER TABLE VND_VENDEDOR ADD DTFINALPERIOINATIVO VARCHAR(15)
/

ALTER TABLE VND_PRODUTOPDV ADD NRDEPARTAMENTO NUMBER(4)
/

ALTER TABLE VND_PRODUTOPDV ADD 
	CONSTRAINT NRDEPARTA_PRODPDV_FK FOREIGN KEY (NRDEPARTAMENTO)
		REFERENCES VND_DEPARTAMENTO(NRDEPARTAMENTO)
/

ALTER TABLE VND_PRODUTOPDV ADD IDPRODCOMPRA VARCHAR(20)
/

ALTER TABLE VND_PRODUTOREGRAPRECO RENAME COLUMN CALCULARNEWLORUNITARIO TO CALCULARNOVALORUNITARIO
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA_FILIAL/LOJA/PDV'
WHERE NRPARAMETRO = '139' AND DESCHIERARQUIA = 'Filial/Loja/PDV'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA'
WHERE NRPARAMETRO = '137' AND DESCHIERARQUIA = 'Filial/Loja'

/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA_FILIAL/LOJA/PDV'
WHERE NRPARAMETRO = '133' AND DESCHIERARQUIA = 'Filial/Loja/PDV'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA_FILIAL/LOJA/PDV'
WHERE NRPARAMETRO = '104' AND DESCHIERARQUIA = 'Filial/Loja/PDV'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA_FILIAL/LOJA/PDV'
WHERE NRPARAMETRO = '104' AND DESCHIERARQUIA = 'Filial/Loja/PDV'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA'
WHERE NRPARAMETRO = '132' AND DESCHIERARQUIA = 'Filial/Loja'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA'
WHERE NRPARAMETRO = '91' AND DESCHIERARQUIA = 'Filial/Loja'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA_FILIAL/LOJA/PDV'
WHERE NRPARAMETRO = '121' AND DESCHIERARQUIA = 'Filial/Loja/PDV'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA_FILIAL/LOJA/PDV'
WHERE NRPARAMETRO = '117' AND DESCHIERARQUIA = 'Filial/Loja/PDV'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA_FILIAL/LOJA/PDV'
WHERE NRPARAMETRO = '116' AND DESCHIERARQUIA = 'Filial/Loja/PDV'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA_FILIAL/LOJA/PDV'
WHERE NRPARAMETRO = '115' AND DESCHIERARQUIA = 'Filial/Loja/PDV'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA_FILIAL/LOJA/PDV'
WHERE NRPARAMETRO = '114' AND DESCHIERARQUIA = 'Filial/Loja/PDV'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA_FILIAL/LOJA/PDV'
WHERE NRPARAMETRO = '113' AND DESCHIERARQUIA = 'Filial/Loja/PDV'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA_FILIAL/LOJA/PDV'
WHERE NRPARAMETRO = '112' AND DESCHIERARQUIA = 'Filial/Loja/PDV'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA_FILIAL/LOJA/PDV'
WHERE NRPARAMETRO = '111' AND DESCHIERARQUIA = 'Filial/Loja/PDV'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA_FILIAL/LOJA/PDV'
WHERE NRPARAMETRO = '110' AND DESCHIERARQUIA = 'Filial/Loja/PDV'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA_FILIAL/LOJA/PDV'
WHERE NRPARAMETRO = '109' AND DESCHIERARQUIA = 'Filial/Loja/PDV'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA_FILIAL/LOJA/PDV'
WHERE NRPARAMETRO = '108' AND DESCHIERARQUIA = 'Filial/Loja/PDV'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA_FILIAL/LOJA/PDV'
WHERE NRPARAMETRO = '103' AND DESCHIERARQUIA = 'Filial/Loja/PDV'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA_FILIAL/LOJA/PDV'
WHERE NRPARAMETRO = '102' AND DESCHIERARQUIA = 'Filial/Loja/PDV'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA'
WHERE NRPARAMETRO = '98' AND DESCHIERARQUIA = 'Filial/Loja'
/

UPDATE VND_RELHIERARQUIAPARAMETRO SET HIERARQUIAVALUE = 'FILIAL_FILIAL/LOJA'
WHERE NRPARAMETRO = '97' AND DESCHIERARQUIA = 'Filial/Loja'